#include <stdio.h>
#include <fcntl.h>
#include <linux/cdrom.h>
#include <linux/types.h>

#define CD_DEVICE "/dev/cdrom"

int main()
{
    int fd, i;

    struct cdrom_tochdr hdr;
    struct cdrom_tocentry toc;

    fd = open(CD_DEVICE, O_RDONLY|O_NONBLOCK);
    if(fd < 0) { perror("open"); return -1; }

    memset((void *)&hdr, 0, sizeof(struct cdrom_tochdr));
    if(ioctl(fd, CDROMREADTOCHDR, &hdr) < 0) {
	perror("ioctl");
	return -1;
    }

    printf("First: %d\t", hdr.cdth_trk0);
    printf("Last: %d\n", hdr.cdth_trk1);

#define FIRST hdr.cdth_trk0
#define LAST hdr.cdth_trk1

    toc.cdte_format = CDROM_LBA;

    for(i = FIRST; i <= LAST; i++) {

	toc.cdte_track = i;

	if(ioctl(fd, CDROMREADTOCENTRY, &toc) < 0) {
	    perror("ioctl");
	    return -1;
	}

	printf("track: %d\t", i);
	printf("lba: %d\n", toc.cdte_addr.lba);
    }

    return 0;
}
