#include <stdio.h>
#include <fcntl.h>
#include <linux/cdrom.h>
#include <linux/types.h>

#define CD_DEVICE "/dev/cdrom"

int main()
{
    int fd, current_track;
    struct cdrom_subchnl sc;

    fd = open(CD_DEVICE, O_RDONLY|O_NONBLOCK);
    if(fd < 0) { perror("open"); return -1; }

    if(ioctl(fd, CDROM_DISC_STATUS) != CDS_AUDIO) {
	printf("I need Audio_CD!\n");
	return 0;
    }

    for(;;) {

	sc.cdsc_format = CDROM_LBA;
	ioctl(fd, CDROMSUBCHNL, &sc);
        current_track = sc.cdsc_trk;
        printf("Track: %d\t", current_track);    
        printf("LBA: %d\t", sc.cdsc_absaddr.lba);

	sc.cdsc_format = CDROM_MSF;
	ioctl(fd, CDROMSUBCHNL, &sc);

        printf("MSF: %d %d %d\n", sc.cdsc_absaddr.msf.minute, \
				sc.cdsc_absaddr.msf.second, \
				sc.cdsc_absaddr.msf.frame);

	sleep(2);
    }

    return 0;
}
