#include <linux/types.h>
#include <linux/cdrom.h>
#include <linux/byteorder/swab.h>

int send_cmd(int fd, __u8 *cmd, unsigned char direction, \
	    __u8 *data, unsigned int datalen)
{
    struct cdrom_generic_command cgc;
    struct request_sense sense;

#define SK sense.sense_key
#define ASC sense.asc
#define ASCQ sense.ascq

    memset((void *)&cgc, 0, sizeof(struct cdrom_generic_command));
    memset(&sense, 0, sizeof(sense));

    memcpy((void *)cgc.cmd, cmd, 12);
    cgc.sense = &sense;

    cgc.data_direction = direction;
    cgc.buffer = data;
    cgc.buflen = datalen;
    cgc.timeout = 20000;

    if(ioctl(fd, CDROM_SEND_PACKET, &cgc) < 0) {
	perror("ioctl CDROM_SEND_PACKET");
	printf("SK/ASC/ASCQ: 0x%02X/0x%02X/0x%02X\n", SK, ASC, ASCQ);
	return -1;
    }

    return 0;
}
