#include <stdio.h>
#include <fcntl.h>
#include <linux/types.h>
#include <linux/cdrom.h>

#define CD_DRIVE "/dev/cdrom2"
int fd;

void test_unit_ready()
{
    int i;
    __u8 test_unit_cmd[CDROM_PACKET_SIZE];

    /* Prepare TEST UNIT command */
    memset(test_unit_cmd, 0, 12);
    test_unit_cmd[0] = GPCMD_TEST_UNIT_READY;

    for(i = 0; i < 20; i++) {
	if(send_cmd(fd, test_unit_cmd, CGC_DATA_NONE, NULL, 0) == 0) return;
	sleep(1);
    }

    printf("\n  .\n");
    exit(-1);
}


int start_stop_unit(__u8 ctrl_field)
{
    __u8 cmd[CDROM_PACKET_SIZE];

    memset((void *)cmd, 0, CDROM_PACKET_SIZE);
    cmd[0] = GPCMD_START_STOP_UNIT;
    cmd[4] = ctrl_field;

    if(send_cmd(fd, cmd, CGC_DATA_NONE, NULL, 0) < 0) return -1;

    return 0;
}


int main()
{
    fd = open(CD_DRIVE, O_RDONLY|O_NONBLOCK);
    if(fd < 0) { perror("open"); return -1; }

    //test_unit_ready();
    start_stop_unit(0x02);

    printf("CD-ROM .  ENTER  ");
    getchar();

    start_stop_unit(0x03);
    //test_unit_ready();

    printf("CD-ROM \n");

    close(fd);
    return 0;
}
