#include <stdio.h>
#include <fcntl.h>
#include <linux/types.h>
#include <linux/cdrom.h>
#include <linux/byteorder/swab.h>

#define CD_DRIVE "/dev/cdrom"
int fd;

void test_unit_ready()
{
    int i;
    __u8 test_unit_cmd[CDROM_PACKET_SIZE];

    /* Prepare TEST UNIT command */
    memset(test_unit_cmd, 0, 12);
    test_unit_cmd[0] = GPCMD_TEST_UNIT_READY;

    for(i = 0; i < 20; i++) {
	if(send_cmd(fd, test_unit_cmd, CGC_DATA_NONE, NULL, 0) == 0) return;
	sleep(1);
    }

    printf("\n  .\n");
    exit(-1);
}


int read_cd(__u32 lba)
{
    int out_f;
    __u8 cmd[12];
    unsigned int datalen;
    __u32 sector;

#define QSCH_LEN 16

/* For READ CD command */
    __u8 blk_buff[CD_FRAMESIZE_RAW + QSCH_LEN];

/* READ CD command */
    memset(cmd, 0, 12);
    memset(blk_buff, 0, sizeof(blk_buff));

    cmd[0] = GPCMD_READ_CD;
    cmd[1] = 0; //   
    cmd[8] = 1; //    
    cmd[9] = 0xF8; //    
    cmd[10] = 2; //   Q-

    lba = __swab32(lba);
    memcpy((cmd + 2), (void *)&lba, 4);

    datalen = CD_FRAMESIZE_RAW + QSCH_LEN;

    test_unit_ready();

    if(send_cmd(fd, cmd, CGC_DATA_READ, blk_buff, datalen) < 0) return -1;

    out_f = open("sector", O_CREAT|O_RDWR|O_TRUNC, 0600);
    if(out_f < 0) { perror("open"); return -1; }

    if(write(out_f, blk_buff, CD_FRAMESIZE_RAW) < 0) {
        perror("write"); return -1;
    }

    out_f = open("data_Q", O_CREAT|O_RDWR|O_TRUNC, 0600);
    if(out_f < 0) { perror("open"); return -1; }

    if(write(out_f, blk_buff + CD_FRAMESIZE_RAW, QSCH_LEN) < 0) {
        perror("write"); return -1;
    }

    close(fd);
    close(out_f);

    return 0;
}


int main()
{
    __u32 sector = 5555;

    fd = open(CD_DRIVE, O_RDONLY|O_NONBLOCK);
    if(fd < 0) { perror("open"); return -1; }

    read_cd(sector);

    return 0;
}
