
/* DISK INFORMATION BLOCK */
typedef struct {
    __u16 disk_info_len;
    __u8 disk_status		:2;
    __u8 state_last_sess	:2;
    __u8 erasable		:1;
    __u8 res			:3;
    __u8 first_track_num;
    __u8 sess_num_lsb;
    __u8 first_trk_num_ls;
    __u8 last_trk_num_ls;
    __u8 BG_format_status	:2;
    __u8 Dbit			:1;
    __u8 res1			:1;
    __u8 DAC_V			:1;
    __u8 URU			:1;
    __u8 DBC_V			:1;
    __u8 DID_V			:1;
    __u8 disk_type;
    __u8 sess_num_msb;
    __u8 first_trk_num_ms;
    __u8 last_trk_num_ms;
    __u32 disk_ident;
    __u32 lead_in_start;
    __u32 lead_out_possible;
    __u8 disk_bar_code[8];
    __u8 disk_appl_code;
    __u8 OPC_table_num;
} __attribute__ ((packed)) disk_info_block_t;

#define DIB_LEN 34

/* DVD STRUCTURE, Format Field = 0x00 */
typedef struct {
    __u8 part_version	:4;
    __u8 book_type	:4;
    __u8 max_rate	:4;
    __u8 disk_size	:4;
    __u8 layer_type	:4;
    __u8 track_path	:1;
    __u8 num_of_layers	:2;
    __u8 rez1		:1;
    __u8 track_dns	:4;
    __u8 linear_dns	:4;
    __u32 start_psn_da;
    __u32 end_psn_da;
    __u32 end_sect_L0;
    __u8 rez2;
} __attribute__ ((packed)) layer_descr_t;


/*  DVD-R/-RW */
typedef struct {
    __u16 f_code;
    __u8 current	:1;
    __u8 persistent	:1;
    __u8 version	:4;
    __u8 res1		:2;
    __u8 add_length;
    __u8 res2		:1;
    __u8 dvd_rw		:1;
    __u8 test_write	:1;
    __u8 res3		:3;
    __u8 BUF		:1;
    __u8 res4		:1;
    __u16 reserved;
    __u8 res5;
} __attribute__ ((packed)) dvd_t;


#define SECT_NUM 32
#define BUFF_SIZE (2048 * SECT_NUM)

/*     */
typedef struct {
    __u8 page_code	:6;
    __u8 rez		:1;
    __u8 ps		:1;
    __u8 page_length;
    __u8 write_type	:4;
    __u8 test_write	:1;
    __u8 ls_v		:1;
    __u8 BUFE		:1;
    __u8 rez1		:1;
    __u8 track_mode	:4;
    __u8 copy		:1;
    __u8 FP		:1;
    __u8 multises	:2;
    __u8 dbt		:4;
    __u8 rez2		:4;
    __u8 link_size;
    __u8 rez3;
    __u8 hac		:6;
    __u8 rez4		:2;
    __u8 s_format;
    __u8 rez5;
    __u32 packet_size;
    __u16 apl;
    __u8 mcn[16];
    __u8 isrc[16];
    __u32 sh;
} __attribute__ ((packed)) wpm_t;

#define DVD_READ 0x001F
#define DVD_RW 0x002F

struct disktypes {
    __u8 dtype; //  
    __u8 *dname; //   
};

struct disktypes disk_types[] = {
    {0x00, "DVD-ROM"},
    {0x01, "DVD-RAM"},
    {0x02, "DVD-R"},
    {0x03, "DVD-RW"},
    {0x09, "DVD+RW"},
    {0x0A, "DVD+R"}
};

#define LOCK 1
#define UNLOCK 0
