/* ,      
 * ATAPI-
 */

#include <linux/types.h>
#include <send_cmd.h>

#define BSY 0x80
#define DRQ 0x08
#define DRDY 0x40
#define ERR 0x01
#define DEV 0 // 0 - Master, 1 - Slave

/*   */
void drive_reset()
{
    __u16 port;
    __u8 status = 0;

/*   */
    port = 0x176; OUT_P_B(0xA0 | (DEV << 4), port);
    port = 0x177; OUT_P_B(0x08, port);

    do {
        IN_P_B(status, port);
    } while(status & BSY);

    return;
}


void send_packet_command(__u8 *cmd_buff)
{
    int i;
    __u8 status = 0;
    __u16 port, a;

    port = 0x177;

    for(;;) {

	do {
	    IN_P_B(status, port);
	} while(status & BSY);

	if(!(status & DRQ)) break;
    }

    port = 0x176; OUT_P_B(0xA0 | (DEV << 4), port); //  
    port = 0x177; OUT_P_B(0xA0, port); //  PACKET

    for(;;) {

	do {
	    IN_P_B(status, port);
	} while(status & BSY);

	if(status & DRQ) break;
    }

    port = 0x170;
    for(i = 0; i < 12; i += 2) {
	*((__u8 *)&a) = cmd_buff[i];
	*((__u8 *)&a + 1) = cmd_buff[i + 1];
	OUT_P_W(a, port);
    }

    port = 0x177;
    for(;;) {

	do {
	    IN_P_B(status, port);
	} while(status & BSY);

	if(status & DRDY) break;
    }

    return;
}


int send_packet_data_command(__u16 data_len, __u8 *cmd_buff)
{
    int i;
    __u8 status = 0;
    __u16 port, a;

    port = 0x177;

    for(;;) {

	do {
	    IN_P_B(status, port);
	} while(status & BSY);

	if(!(status & DRQ)) break;
    }

    port = 0x174; OUT_P_B((__u8)data_len, port);
    port = 0x175; OUT_P_B((data_len >> 8), port);
    port = 0x176; OUT_P_B(0xA0 | (DEV << 4), port);
    port = 0x177; OUT_P_B(0xA0, port);

    for(;;) {

	do {
	    IN_P_B(status, port);
	} while(status & BSY);

	if(status & DRQ) break;
    }

    port = 0x170;
    for(i = 0; i < 12; i += 2) {
	*((__u8 *)&a) = cmd_buff[i];
	*((__u8 *)&a + 1) = cmd_buff[i + 1];
	OUT_P_W(a, port);
    }

    port = 0x177;
    for(;;) {

	do {
	    IN_P_B(status, port);
	} while(status & BSY);

	if(status & ERR) return -1;
	if(status & DRQ) break;
    }

    return 0;
}
