/*     - */

#include <stdio.h>
#include <fcntl.h>
#include <linux/types.h>
#include <linux/byteorder/swab.h>
#include <linux/cdrom.h>
#include <send_cmd.h>


/*    */
void test_unit_ready()
{
    __u8 cmd_buff[12];
    memset((void *)cmd_buff, 0, 12);
    cmd_buff[0] = 0x00;
    send_packet_command(cmd_buff);

    return;
}


int request_sense()
{
    int i = 0;
    __u8 cmd_buff[12];
    __u8 sense_buff[14];
    __u16 a;

#define SK (sense_buff[2] & 0x0F)
#define ASC sense_buff[12]
#define ASCQ sense_buff[13]

    memset((void *)cmd_buff, 0, 12);
    memset((void *)sense_buff, 0, 14);

    cmd_buff[0] = 0x3;
    cmd_buff[4] = 14;

    if(send_packet_data_command(14, cmd_buff) < 0) {
	printf("Error request sense\n");
	exit(-1);
    }

    for(i = 0; i < 14; i += 2) {
        IN_P_W(a, 0x170);
	sense_buff[i] = *(__u8 *)&a;
	sense_buff[i + 1] = *((__u8 *)&a + 1);
    }

    fprintf(stderr, "SK/ASC/ASCQ: 0x%X/0x%X/0x%X\n", SK, ASC, ASCQ);
    fflush(stderr);

    return 0;
}


/*    */
int read_cd(__u32 lba)
{
    int i = 0, out_f, ret;
    __u8 cmd_buff[12];
    __u8 buff[CD_FRAMESIZE_RAW];
    __u16 a = 0;

    memset((void *)buff, 0, sizeof(buff));
    memset((void *)cmd_buff, 0, 12);

    cmd_buff[0] = 0xBE;
    cmd_buff[1] = 0;
    cmd_buff[9] = 0xF8;
    cmd_buff[8] = 1;

    printf("LBA: %u\n", lba);
    lba = __swab32(lba);

    memcpy((cmd_buff + 2), (void *)&lba, 4);

    if(send_packet_data_command(CD_FRAMESIZE_RAW, cmd_buff) < 0) {
	request_sense();
	return -1;
    }

    for(i = 0; i < CD_FRAMESIZE_RAW; i += 2) {
        IN_P_W(a, 0x170);
	buff[i] = *((__u8 *)&a);
	buff[i + 1] = *((__u8 *)&a + 1);
    }

    out_f = open("sector", O_CREAT|O_RDWR, 0600);
    if(out_f < 0) { perror("open"); return -1; }

    ret = write(out_f, buff, sizeof(buff));
    if(ret < 0) { perror("write"); return -1; }

    return 0;
}


int main()
{
    __u32 lba = 1001;

    ioperm(0x170, 8, 1);

    drive_reset();

    test_unit_ready();
    if(read_cd(lba) < 0) printf("Error read CD\n");

    ioperm(0x170, 8, 0);

    return 0;
}
