/*    CD Track at Once   */

#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <scsi/scsi.h>
#include <scsi/sg.h>
#include <linux/types.h>
#include <linux/byteorder/swab.h>

#define SG_DEV "/dev/sg0" //  
#define CD_TAO 0x002D //   

int sg_fd; //  

/*  CD Track at Once */
typedef struct {
    __u16 f_code;
    __u8 current	:1;
    __u8 persistent	:1;
    __u8 version	:4;
    __u8 res1		:2;
    __u8 add_length;
    __u8 rw_subcode	:1;
    __u8 cd_rw		:1;
    __u8 test_write	:1;
    __u8 rw_pack	:1;
    __u8 rw_raw		:1;
    __u8 res2		:1;
    __u8 BUF		:1;
    __u8 res3		:1;
    __u8 reserved;
    __u16 data_type_support;
} __attribute__ ((packed)) cd_tao_t;


int check_feature(__u16 f_num)
{
    __u8 get_conf_cmd[10];
    __u8 data_buff[16]; //  
    __u32 data_len = 0; //   
    __u16 cur_prof = 0; //  , Current Profile

    cd_tao_t *cd_tao;

    test_unit_ready(sg_fd);

    memset(data_buff, 0, sizeof(data_buff));
    cd_tao = (void *)(data_buff + 8);

    memset(get_conf_cmd, 0, 10);
    get_conf_cmd[0] = 0x46; // GET CONFIGURATION
    get_conf_cmd[1] = 2; // RT = 10b
    get_conf_cmd[2] = *((__u8 *)&f_num + 1);
    get_conf_cmd[3] = *((__u8 *)&f_num);
    get_conf_cmd[8] = 16; //   

    if(send_cmd(sg_fd, get_conf_cmd, 10, SG_DXFER_FROM_DEV, data_buff, 16, 200) < 0) return -1;

    memcpy((void *)&data_len, data_buff, 4);
    data_len = __swab32(data_len);
    if(data_len == 4) return -1; //   

/*   */
    *((__u8 *)&cur_prof) = data_buff[7];
    *((__u8 *)&cur_prof + 1) = data_buff[6];
    printf("\nCurrent profile: 0x%04X\n", cur_prof);

/*   CD-RW */
    printf("CD-RW bit: %d\n", cd_tao->cd_rw);

/*   Current */
    printf("Current bit: %d\n", cd_tao->current);

    return 0;
}


int main()
{
    sg_fd = open(SG_DEV, O_RDWR);
    if(sg_fd <0) { perror("open"); return -1; }

    printf("Check CD TAO Feature:");
    if(check_feature(CD_TAO) < 0) printf(" not supported\n");
    else printf("OK\n");

    close(sg_fd);
    return 0;
}
