
/* Disk Information Block (   ) */
typedef struct {
    __u16 disk_info_len;
    __u8 disk_status		:2;
    __u8 state_last_sess	:2;
    __u8 erasable		:1;
    __u8 res			:3;
    __u8 first_track_num;
    __u8 sess_num_lsb;
    __u8 first_trk_num_ls;
    __u8 last_trk_num_ls;
    __u8 BG_format_status	:2;
    __u8 Dbit			:1;
    __u8 res1			:1;
    __u8 DAC_V			:1;
    __u8 URU			:1;
    __u8 DBC_V			:1;
    __u8 DID_V			:1;
    __u8 disk_type;
    __u8 sess_num_msb;
    __u8 first_trk_num_ms;	// First track number in Last session (Most Sign. Bit)
    __u8 last_trk_num_ms;	// Last track number in Last session (Most Sign. Bit)
    __u32 disk_ident;		// Disk Identification
    __u32 lead_in_start;	// Last session Lead-In Start Address
    __u8 l_out[4];		// Lead-Out possible
    __u8 disk_bar_code[8];
    __u8 disk_appl_code;
    __u8 OPC_table_num;
} __attribute__ ((packed)) disk_info_block_t;

#define DIB_LEN 34

/*  CD Mastering */
typedef struct {
    __u16 f_code;
    __u8 current	:1;
    __u8 persistent	:1;
    __u8 version	:4;
    __u8 res1		:2;
    __u8 add_length;
    __u8 rw		:1;
    __u8 cd_rw		:1;
    __u8 test_write	:1;
    __u8 raw		:1;
    __u8 raw_ms		:1;
    __u8 sao		:1;
    __u8 BUF		:1;
    __u8 res2		:1;
    __u8 max_cue_len[3];
} __attribute__ ((packed)) cd_sao_t;

#define CD_SAO 0x002E


/*       */
typedef struct {
    __u8 page_code	:6;
    __u8 rez		:1;
    __u8 ps		:1;
    __u8 page_length;
    __u8 write_type	:4;
    __u8 test_write	:1;
    __u8 ls_v		:1;
    __u8 BUFE		:1;
    __u8 rez1		:1;
    __u8 track_mode	:4;
    __u8 copy		:1;
    __u8 FP		:1;
    __u8 multises	:2;
    __u8 dbt		:4;
    __u8 rez2		:4;
    __u8 link_size;
    __u8 rez3;
    __u8 hac		:6;
    __u8 rez4		:2;
    __u8 s_format;
    __u8 rez5;
    __u32 packet_size;
    __u16 apl;
    __u8 mcn[16];
    __u8 isrc[16];
    __u32 sh;
} __attribute__ ((packed)) wpm_t;

#define SG_DEV "/dev/sg0"
#define SECT_NUM 10
#define BUFF_SIZE (CD_FRAMESIZE_RAW * SECT_NUM)
#define MSF2LBA(Min, Sec, Frame) (((Min * 60 + Sec) * 75 + Frame) - 150)
#define TEST_RECORD_ON 1 //     
#define TEST_RECORD_OFF 0 //     

#define LBA2MIN(LBA) ((LBA + 150) / (60 * 75))
#define LBA2SEC(LBA, MIN) ((LBA + 150 - (MIN * 60 * 75)) / 75)
#define LBA2FRAME(LBA, MIN, SEC) ((LBA + 150 - (MIN * 60 * 75)) - (SEC * 75))
