/* DISK INFORMATION BLOCK */
typedef struct {
    __u16 disk_info_len;
    __u8 disk_status		:2;
    __u8 state_last_sess	:2;
    __u8 erasable		:1;
    __u8 res			:3;
    __u8 first_track_num;
    __u8 sess_num_lsb;
    __u8 first_trk_num_ls;
    __u8 last_trk_num_ls;
    __u8 BG_format_status	:2;
    __u8 Dbit			:1;
    __u8 res1			:1;
    __u8 DAC_V			:1;
    __u8 URU			:1;
    __u8 DBC_V			:1;
    __u8 DID_V			:1;
    __u8 disk_type;
    __u8 sess_num_msb;
    __u8 first_trk_num_ms;
    __u8 last_trk_num_ms;
    __u32 disk_ident;
    __u32 lead_in_start;
    __u8 l_out[4];	// Lead-Out possible
    __u8 disk_bar_code[8];
    __u8 disk_appl_code;
    __u8 OPC_table_num;
} __attribute__ ((packed)) disk_info_block_t;

#define DIB_LEN 34


/*   TOC */
typedef struct {
    __u8 snum;		// Session Number
    __u8 ctrl	:4;	// Control
    __u8 adr	:4;	// ADR
    __u8 tno;		// TNO (always 0)
    __u8 point;		// POINT
    __u8 min;		// AMIN
    __u8 sec;		// ASEC
    __u8 frame;		// AFRAME
    __u8 zero;		// 0
    __u8 pmin;		// PMIN
    __u8 psec;		// PSEC
    __u8 pframe;	// PFRAME
} __attribute__ ((packed)) toc_t;


/*     */
typedef struct {
    __u8 res1;
    __u8 ctrl	:4;
    __u8 adr	:4;
    __u8 first_trk;
    __u8 res2;
    __u32 start_addr;
} __attribute__ ((packed)) ms_info_t;


/*       */
typedef struct {
    __u8 page_code	:6;
    __u8 rez		:1;
    __u8 ps		:1;
    __u8 page_length;
    __u8 write_type	:4;
    __u8 test_write	:1;
    __u8 ls_v		:1;
    __u8 BUFE		:1;
    __u8 rez1		:1;
    __u8 track_mode	:4;
    __u8 copy		:1;
    __u8 FP		:1;
    __u8 multises	:2;
    __u8 dbt		:4;
    __u8 rez2		:4;
    __u8 link_size;
    __u8 rez3;
    __u8 hac		:6;
    __u8 rez4		:2;
    __u8 s_format;
    __u8 rez5;
    __u32 packet_size;
    __u16 apl;
    __u8 mcn[16];
    __u8 isrc[16];
    __u32 sh;
} __attribute__ ((packed)) wpm_t;


/*  CD Track at Once */
typedef struct {
    __u16 f_code;
    __u8 current	:1;
    __u8 persistent	:1;
    __u8 version	:4;
    __u8 res1		:2;
    __u8 add_length;
    __u8 rw_subcode	:1;
    __u8 cd_rw		:1;
    __u8 test_write	:1;
    __u8 rw_pack	:1;
    __u8 rw_raw		:1;
    __u8 res2		:1;
    __u8 BUF		:1;
    __u8 res3		:1;
    __u8 reserved;
    __u16 data_type_support;
} __attribute__ ((packed)) cd_tao_t;

#define CD_TAO 0x002D
#define SECT_NUM 10
#define BUFF_SIZE (CD_FRAMESIZE * SECT_NUM)
#define MSF2LBA(Min, Sec, Frame) (((Min * 60 + Sec) * 75 + Frame) - 150)
